/*****SMART TRIALROOM SWITCH BY A.SAMIUDDHIN*****/

#define RELAY 0
#define REEDSWITCH 1
#define PIR 2
#define REDLED 3
#define GREENLED 4
boolean pirstate;
boolean doorstate;
boolean state = LOW;
unsigned int c = 0;

void setup()
{
pinMode(PIR, INPUT);
pinMode(REEDSWITCH, INPUT);
pinMode(PIR, INPUT_PULLUP);
pinMode(REEDSWITCH, INPUT_PULLUP);
pinMode(RELAY, OUTPUT);
pinMode(REDLED, OUTPUT);
pinMode(GREENLED, OUTPUT);
}

void loop()
{
  pirstate = digitalRead(PIR);
  doorstate = digitalRead(REEDSWITCH);
  if((pirstate == LOW)&&(doorstate ==LOW)) //ROOM OCCUPIED
  {
    digitalWrite(GREENLED, LOW);
    digitalWrite(REDLED, HIGH);
    digitalWrite(RELAY, HIGH);
    delay(500);
    c=0;
  }
  else if((pirstate == LOW)&&(doorstate == HIGH)) //PERSON ENTERS/EXITS  
  {
    state = !state;
    digitalWrite(RELAY, HIGH);
    digitalWrite(GREENLED, state);
    digitalWrite(REDLED, state);
    delay(500);
    c=0;
  }
  else if((pirstate == HIGH)&&(doorstate == LOW)) //ROOM EMPTY/DOOR CLOSED
  {
    digitalWrite(GREENLED, HIGH);
    digitalWrite(REDLED, LOW);
    digitalWrite(RELAY, LOW);
    c=0;
  }
  else                                            //DOOR OPENS
  {
    state = !state;
    digitalWrite(GREENLED, state);
    digitalWrite(REDLED, !state);
    c++;
    delay(500);
    if(c<=20)
    {
      digitalWrite(RELAY, HIGH);
    }
    else
    {
      digitalWrite(RELAY, LOW);
    }
  }
}
